EDIT - bug #5639

NPE when showing name relationships for a name originally related to a deleted name
03/11/2016 03:36 PM - Andreas Mdller

Status: In Progress Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 0%
Category: taxeditor Estimated time: 2:00 hours
Target version: Reviewed Next Major Release

Severity: normal Found in Version:

Description

| deleted a name from Cuba Checklist (id = 2949).
Afterwards | tried to show the name relationships for Chloris barbata (L.) Nash and got the following error:

Maybe this is not reproducable easily because it is related to data cached in the editor. As far as | remember there was no direct
name relationship between these 2 names.

It only happened in the bulk editor, not in the name editor.

login : admin
editor version : 3.12.4
server : api.cybertaxonomy.org / cybertaxonomy.org
schema version : 3.6.0.0.201527040000
os : Windows Server 2012 6.2 amd64
java : 1.7.0_75
java.lang.NullPointerException: CDM Entity of type eu.etaxonomy.cdm.model.name.TaxonNameBase with
id 2949 is null.
at eu.etaxonomy.taxeditor.service.CachedCommonServiceImpl.find(CachedCommonServiceImpl. java:48

at org.hibernate.proxy.AbstractlLazyInitializer.remoteInitialize (AbstractLazyInitializer. java:4
49)

at org.hibernate.proxy.AbstractlLazyInitializer.initialize (AbstractLazyInitializer.java:167)

at org.hibernate.proxy.AbstractLazyInitializer.getImplementation (AbstractLazyInitializer. java:
295)

at org.hibernate.proxy.pojo.javassist.JavassistLazyInitializer.invoke (JavassistLazyInitializer
.java:185)

at eu.etaxonomy.cdm.model.name.TaxonNameBase_$$_Jjavassist_6.getTitleCache (TaxonNameBase_$$_jav
assist_6.java)

at eu.etaxonomy.taxeditor.ui.section.name.NameRelationshipDetailElement.setEntity (NameRelation
shipDetailElement. java:74)

at eu.etaxonomy.taxeditor.ui.section.name.NameRelationshipDetailElement.setEntity (NameRelation
shipDetailElement. java:1)

at eu.etaxonomy.taxeditor.ui.section.supplemental.AbstractReferencedEntityElement.setEntity (Ab
stractReferencedEntityElement. java:1l)

at eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement.<init> (AbstractEntityColl
ectionElement.java:137)

at eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement.<init> (AbstractEntityColl
ectionElement. java:68)

at eu.etaxonomy.taxeditor.ui.section.supplemental.AbstractReferencedEntityElement.<init> (Abstr
actReferencedEntityElement. java:39)

at eu.etaxonomy.taxeditor.ui.section.name.NameRelationshipDetailElement.<init> (NameRelationshi
pDetailElement. java:55)

at eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.createEntityCollectionElement (CdmFormFacto
ry.java:2508)

at eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection.createElementComposite (Ab
stractEntityCollectionSection. java:234)

at eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection.createDynamicContents (Abs
tractEntityCollectionSection. java:222)

at eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection.renderContent (AbstractEnt
ityCollectionSection.java:191)

at eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection.expansionStateChanged (Abs
tractEntityCollectionSection. java:276)
ExpandableComposite.toggleState (ExpandableComposite.java:1065)
ExpandableComposite.access$h (ExpandableComposite. java:1061)
ExpandableComposite$2.linkActivated (ExpandableComposite. java:5

.AbstractHyperlink.handleActivate (AbstractHyperlink. java:233)
.AbstractHyperlink.handleMouseUp (AbstractHyperlink. java:327)
.AbstractHyperlink.access$2 (AbstractHyperlink. java:311)

.AbstractHyperlink$4.handleEvent (AbstractHyperlink. java:125)

.widgets.EventTable.sendEvent (EventTable. java:84)

.internal.
internal.
.internal.
internal.

widgets.
widgets.
widgets.

Widget .sendEvent (Widget. java:1053)
Display.runDeferredEvents (Display.java:4165)
Display.readAndDispatch (Display.java:3754)
Workbench.runEventLoop (Workbench. java:2701)
Workbench.runUI (Workbench. java:2665)
Workbench.access$4 (Workbench. java:2499)
Workbench$7.run (Workbench. java:679)
core.databinding.observable.Realm.runWithDefault (Realm. java:332)
ui.internal.Workbench.createAndRunWorkbench (Workbench. java:668)
ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:149)

eu.etaxonomy.taxeditor.Application.start (Application. java:24)
.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)

.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLaunc

core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher. java:

core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:344)
core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:179)

.NativeMethodAccessorImpl.invokeO (Native Method)

.NativeMethodAccessorImpl.invoke (Unknown Source)

.DelegatingMethodAccessorImpl.invoke (Unknown Source)
java.lang.reflect.Method.invoke (Unknown Source)
org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:622)
org.eclipse.equinox.launcher.Main.basicRun (Main. java:577)
org.eclipse.equinox.launcher.Main.run (Main.java:1410)

History

#1 - 03/16/2016 02:16 PM - Andreas Miller

- Target version changed from Unassigned CDM tickets to Release 4.0

- Priority changed from New to Priority14

#2 - 05/02/2016 03:06 PM - Andreas Miuller

- Target version changed from Release 4.0 to Release 4.1

#3 - 06/01/2016 01:23 PM - Andreas Miuller

- Target version changed from Release 4.1 to Release 4.2

#4 - 07/06/2016 03:21 PM - Andreas Miiller

- Target version changed from Release 4.2 to Release 4.3

#5 - 09/23/2016 03:33 PM - Andreas Miuller

- Target version changed from Release 4.3 to Release 4.4

#6 - 09/26/2016 01:31 PM - Andreas Miuller

- Description updated

- Priority changed from Priority14 to Highest

- Estimated time set to 2:00 h

#7 - 12/01/2016 02:45 PM - Andreas Miller
- Target version changed from Release 4.4 to Release 4.5

#8 - 01/19/2017 01:36 PM - Andreas Miiller

- Target version changed from Release 4.5 to Release 4.6

#9 - 02/15/2017 02:10 PM - Katja Luther

| could reproduce it with following settings:

name1 has nameRelation to name2 and hame2 has another nameRelation to name3 which | deleted in DB.

Search for name1 in bulk editor and click on namerelationships -> Exception

This is because the second nameRelation of name2 points to a name that does not exist anymore. This is a problem of corrupted data and so the
error message is correct. Maybe we can show a better message dialog to the user.

#10 - 02/15/2017 05:26 PM - Andreas Miiller

Katja Luther wrote:
| could reproduce it with following settings:

name1 has nameRelation to name2 and name2 has another nameRelation to name3 which | deleted in DB.

Search for name1 in bulk editor and click on namerelationships -> Exception

This is because the second nameRelation of name2 points to a name that does not exist anymore. This is a problem of corrupted data and so
the error message is correct. Maybe we can show a better message dialog to the user.

| think this should be handled a bit earlier. When deleting name3 the delete operation should have decided (via configuration, user feedback or what

ever) how to handle the name relationship. If the decision was that the name relationship can be deleted (e.g. because name3 is the "to"-part in a "is

basionym for" realtionship) then it should be fully deleted during deletion of name2 and therefore no error should be thrown during save of name1 or

2. If the decision was that the relationship can not be deleted than the feedback should be given during deletion of name3 and the name must not be
deleted.

But maybe | misunderstand the whole setting here.

#11 - 03/10/2017 08:45 PM - Andreas Miiller

- Target version changed from Release 4.6 to Release 4.7

#12 - 05/11/2017 03:59 PM - Andreas Miiller

- Target version changed from Release 4.7 to Release 4.8
#13 - 05/31/2017 12:47 PM - Katja Luther
Andreas Miller wrote:
Katja Luther wrote:
| could reproduce it with following settings:
name1 has nameRelation to name2 and name2 has another nameRelation to name3 which | deleted in DB.
Search for name1 in bulk editor and click on namerelationships -> Exception

This is because the second nameRelation of name2 points to a name that does not exist anymore. This is a problem of corrupted data and
so the error message is correct. Maybe we can show a better message dialog to the user.

| think this should be handled a bit earlier. When deleting name3 the delete operation should have decided (via configuration, user feedback or
what ever) how to handle the name relationship. If the decision was that the name relationship can be deleted (e.g. because name3 is the
"to"-part in a "is basionym for" realtionship) then it should be fully deleted during deletion of name2 and therefore no error should be thrown
during save of name1 or 2. If the decision was that the relationship can not be deleted than the feedback should be given during deletion of
name3 and the name must not be deleted.

But maybe | misunderstand the whole setting here.

But the problem was, that name3 was deleted in DB not by a delete operation of cdmlib. Normally this should not be happen. But in the description of
this ticket you also said that the name was deleted in DB.

#14 - 06/20/2017 05:39 PM - Andreas Miiller

Katja Luther wrote:

Andreas Muller wrote:
| think this should be handled a bit earlier. When deleting name3 the delete operation should have decided (via configuration, user feedback
or what ever) how to handle the name relationship. If the decision was that the name relationship can be deleted (e.g. because name3 is
the "to"-part in a "is basionym for" realtionship) then it should be fully deleted during deletion of name2 and therefore no error should be
thrown during save of name1 or 2. If the decision was that the relationship can not be deleted than the feedback should be given during
deletion of name3 and the name must not be deleted.

But maybe | misunderstand the whole setting here.

But the problem was, that name3 was deleted in DB not by a delete operation of cdmlib. Normally this should not be happen. But in the
description of this ticket you also said that the name was deleted in DB.

| did not write in the description that | deleted it directly via SQL. | probably deleted it via TaxEdtior. The editor should NEVER lead to a situation
where data becomes inconsistent (I also wonder why hibernate allows this). This is only possible because we use MySQL ISAM which has not
referential integrity checking. Otherwise it could not happen. However, it shows that there is probably a mistake in the way how the delete was
executed or it is just a non existing (because deleted) object within an TaxEditor session.

As mentioned in the description | do not know if it is easily reproducable. We should at least play around a bit and try to reproduce.

#15 - 07/07/2017 01:39 PM - Andreas Miiller

- Status changed from New to In Progress

#16 - 07/21/2017 12:45 PM - Katja Luther

- Target version changed from Release 4.8 to Release 4.10

as | could not reproduce it without deleting the name in the database, we have to move the ticket and try to play around to reproduce it from time to
time.

#17 - 09/24/2017 01:26 AM - Andreas Muller

- Target version changed from Release 4.10 to Release 4.12

#18 - 12/05/2017 02:05 PM - Andreas Miiller

- Target version changed from Release 4.12 to Release 4.13

#19 - 01/31/2018 04:41 PM - Andreas Miiller

- Private changed from Yes to No

#20 - 02/16/2018 12:28 PM - Katja Luther

- Target version changed from Release 4.13 to Release 5.0

#21 - 05/17/2018 04:24 PM - Katja Luther

- Target version changed from Release 5.0 to Release 5.1

#22 - 06/28/2018 09:08 AM - Katja Luther

- Target version changed from Release 5.1 to Release 5.3

#23 - 09/06/2018 01:23 PM - Katja Luther

- Target version changed from Release 5.3 to Release 5.4

#24 - 10/23/2018 11:00 AM - Andreas Muller

- Target version changed from Release 5.4 to Release 5.5

#25 - 02/19/2019 02:43 PM - Andreas Miiller

- Target version changed from Release 5.5 to Release 5.6

#26 - 02/19/2019 03:12 PM - Andreas Miiller

- Target version changed from Release 5.6 to Reviewed Next Major Release
